﻿using System;
using System.Collections.Generic;
using UnityEngine;

namespace CarMod
{
	public class CarMod : MonoBehaviour
	{
		public static void Main()
		{

		ModAPI.Register(
	 new Modification()
	        {
		        OriginalItem = ModAPI.FindSpawnable("Tank"),
		        NameOverride = "T-90",
		        NameToOrderByOverride = "!",
		        DescriptionOverride = "The T-90 is a third-generation Russian main battle tank. It uses a 125 mm 2A46 smoothbore main gun, the 1A45T fire-control system, an upgraded engine, and gunner's thermal sight.",
		        CategoryOverride = ModAPI.FindCategory("Vehicles"),
		        ThumbnailOverride = ModAPI.LoadSprite("Textures/Thumb.png"),
		        AfterSpawn = (Instance) =>
		        {
			    //Main
                    Destroy(Instance.GetComponentInChildren<RandomCarTextureBehaviour>());
                    var TankHead = Instance.transform.Find("Head");
                    var TankBody = Instance.transform.Find("Body"); 
                    var TankBarrel = Instance.transform.Find("Barrel"); 
                    var TankGasTank = Instance.transform.Find("Gas tank"); 
                    var TankEngine = Instance.transform.Find("Engine"); 

                    var TankSettings = TankBody.GetComponent<CarBehaviour>();
                    TankSettings.MotorSpeed = -500f;
                    TankSettings.WaterProof = false;
                    
                    var BarrelSettings = TankBarrel.GetComponent<TankBarrelBehaviour>();
                    BarrelSettings.RecoilIntensity = 25f; //15
                    BarrelSettings.barrelPosition = new Vector2(3.67f, 0f);
                    //BarrelSettings.barrelPosition = new Vector2(3.67f, 0f);
                    BarrelSettings.barrelDirection = new Vector2(1, 0);

                //DestroyColliders
                    BoxCollider2D[] boxColliders = TankHead.GetComponents<BoxCollider2D>();
                    GameObject.Destroy(boxColliders[0]);
                    GameObject.Destroy(boxColliders[1]);
                    GameObject.Destroy(boxColliders[2]);

                    BoxCollider2D[] boxColliders2 = TankBody.GetComponents<BoxCollider2D>();
                    GameObject.Destroy(boxColliders2[0]);
                    GameObject.Destroy(boxColliders2[1]);
                    GameObject.Destroy(boxColliders2[2]);
                    GameObject.Destroy(boxColliders2[3]);
                    GameObject.Destroy(boxColliders2[4]);

                    BoxCollider2D[] boxColliders3 = TankBarrel.GetComponents<BoxCollider2D>();
                    GameObject.Destroy(boxColliders3[0]);

                //Tank Head
			        TankHead.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                    {
                        ModAPI.LoadSprite("Textures/Head.png"),
                    };
                    PolygonCollider2D TankHeadColl = TankHead.GetComponent<PolygonCollider2D>();
                    TankHeadColl.pathCount = 1;
                    TankHeadColl.SetPath(0, new Vector2[]
                    {
                        new Vector2(2.31267595f,-0.0849173665f),
                        new Vector2(2.00496101f,-0.0803747177f),
                        new Vector2(2.00418472f,0.0832557678f),
                        new Vector2(1.76659918f,0.202406734f),
                        new Vector2(0.11991109f,0.207235187f),
                        new Vector2(-0.0249627791f,0.374241263f),
                        new Vector2(-0.880884886f,0.3770549f),
                        new Vector2(-1.00098169f,0.281051278f),
                        new Vector2(-1.30807483f,0.285295606f),
                        new Vector2(-1.59932995f,0.229243368f),
                        new Vector2(-1.60201383f,0.115940243f),
                        new Vector2(-1.97002625f,0.118170187f),
                        new Vector2(-2.03156877f,-0.0181653798f),
                        new Vector2(-2.22287655f,-0.0283085704f),
                        new Vector2(-2.44368887f,-0.305844843f),
                        new Vector2(-2.29555511f,-0.460716248f),
                        new Vector2(-2.01056862f,-0.487051964f),
                        new Vector2(-1.91908836f,-0.596637726f),
                        new Vector2(-1.29601324f,-0.667286992f),
                        new Vector2(-1.14401054f,-0.83049202f),
                        new Vector2(2.22862005f,-0.830693364f),
                        new Vector2(2.48991203f,-0.778344154f),
                        new Vector2(2.55170703f,-0.687524617f),
                        new Vector2(2.74964905f,-0.687410355f),
                        new Vector2(2.74270129f,-0.145134866f)
                    });
                //Body	
					TankBody.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                    {
                        ModAPI.LoadSprite("Textures/Body.png"),	
                    };
                    PolygonCollider2D TankBodydColl = TankBody.gameObject.AddComponent<PolygonCollider2D>();
                    TankBodydColl.pathCount = 1;
                    TankBodydColl.SetPath(0, new Vector2[]
                    {
                        new Vector2(3.9439249f,-0.689985454f),
                        new Vector2(5.14605951f,0.0140409991f),
                        new Vector2(4.92438173f,0.237194002f),
                        new Vector2(3.45712376f,0.416749746f),
                        new Vector2(2.81131911f,0.605913877f),
                        new Vector2(-1.57537675f,0.600295603f),
                        new Vector2(-4.35036182f,0.602947235f),
                        new Vector2(-4.73823261f,0.578799248f),
                        new Vector2(-4.8592453f,0.421334505f),
                        new Vector2(-4.82207727f,0.145267516f),
                        new Vector2(-5.01007986f,0.144032419f),
                        new Vector2(-5.11150217f,0.0424248576f),
                        new Vector2(-4.96171856f,-0.0914652422f),
                        new Vector2(-4.83098459f,-0.09993729f),
                        new Vector2(-2.07142854f,-0.681174457f)
                    });
                //Barrel							
			        TankBarrel.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                	{
                        ModAPI.LoadSprite("Textures/Barrel.png"),
                    };
                    PolygonCollider2D TankBarrelColl = TankBarrel.gameObject.AddComponent<PolygonCollider2D>();
                    TankBarrelColl.pathCount = 1;
                    TankBarrelColl.SetPath(0, new Vector2[]
                    {
                        new Vector2(3.63382626f,-0.187679455f),
                        new Vector2(3.62857151f,0.0444916934f),
                        new Vector2(1.27019119f,0.0438285321f),
                        new Vector2(1.26312613f,0.109186038f),
                        new Vector2(-2.01054716f,0.110178873f),
                        new Vector2(-2.05666494f,0.166226253f),
                        new Vector2(-3.62857151f,0.163938388f),
                        new Vector2(-3.62857151f,-0.302218854f),
                        new Vector2(-2.06096077f,-0.304507673f),
                        new Vector2(-2.01322508f,-0.246433079f),
                        new Vector2(1.26206696f,-0.247119069f),
                        new Vector2(1.26295066f,-0.184389889f)
                    });				
                //Gas Tank
			        Instance.transform.Find("Gas tank").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                	{
                        ModAPI.LoadSprite("Textures/Gastank.png"),
                    };	
                //Engine
			        Instance.transform.Find("Engine").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                	{
                        ModAPI.LoadSprite("Textures/Engine.png"),
                    };	
			    //Wheels
			            Instance.transform.Find("Wheel").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel1.png"),
                                };

			            Instance.transform.Find("Wheel (1)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
               	                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			            Instance.transform.Find("Wheel (2)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			            Instance.transform.Find("Wheel (3)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			            Instance.transform.Find("Wheel (4)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };
			
		                Instance.transform.Find("Wheel (5)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			            Instance.transform.Find("Wheel (6)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			            Instance.transform.Find("Wheel (7)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                        };

			            Instance.transform.Find("Wheel (8)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                                    ModAPI.LoadSprite("Textures/Wheel1.png"),
                        };
                //Other
                    Instance.AddComponent<NoChildrenCollide>();
                    NoCollide noCollide = Instance.AddComponent<NoCollide>();
                    noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                    noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                
			        }
		        }
	    );

		//Tank Mounts
		ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "A Tankmount for T-90 - 1",
                    NameToOrderByOverride = "A Tankmount for T-90 - 1",
                    DescriptionOverride = "This is a Gun Mount for the T-90.",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Mount1Thumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Mount1.png", 1f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 13f;
                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.FixColliders();
                    }
                }
			);

		ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "A Tankmount for T-90 - 2",
                    NameToOrderByOverride = "A Tankmount for T-90 - 2",
                    DescriptionOverride = "This is a Gun Mount for the T-90.",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Mount2Thumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Mount2.png", 1f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 13f;
                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.FixColliders();
                    }
                }
			);
            

		}
	}
	     
}

